#lang racket


(define (ack m n)
  (cond [(= m 0) (+ n 1)]
        [(= n 0) (ack (- m 1) 1)]
        [else (ack (- m 1) (ack m (- n 1)))]))


(define (st-ack m n)
  (define (ret v st)
    (match st
      [`(ack-m ,m ,st1)
       (tail-ack m v st1)]
      [else v]))
  (define (tail-ack m n st)
    (cond [(= m 0) (ret (+ n 1) st)]
          [(= n 0) (tail-ack (- m 1) 1 st)]
          [else (tail-ack m (- n 1) `(ack-m ,(- m 1) ,st))]))
  (tail-ack m n '()))

